#include "minmax-chisq_fn.h"
int main(int argc, char **argv)
{
#define NCHAR 20
  FILE *binfile,*binfile_in; 
  char *seqc,(*name)[11];
  int i,irand,numsp,nbinl,nbinu,nbin,iseed,nrand,*seq,bin[NCHAR],bint[NCHAR];
  int crit_id=1,nsite,*nsitev;
  double fr[NCHAR],*fmat,*pfarray,crit,crit_new;

  get_params(argc,argv,&binfile,&binfile_in,&iseed,&nrand,&nbinl,&nbinu);
/*   printf("%i %i %i %i\n",iseed,nrand,nbinl,nbinu); */
/*   if(binfile_in==NULL) printf("No infile\n");  */
  srand48(iseed); 

  fscanf(stdin, "%i %i", &numsp, &nsite); 
  name = (char (*)[11]) malloc((size_t) numsp*sizeof(*name));
  nsitev = (int *) malloc((size_t) numsp*sizeof(int));
  seqc = (char *) malloc((size_t) numsp*nsite*sizeof(char));
  seq = (int *) malloc((size_t) numsp*nsite*sizeof(int));
  fmat = (double *) malloc((size_t) numsp*NCHAR*sizeof(double));
  pfarray = (double *) malloc((size_t) numsp*numsp*NCHAR*NCHAR*sizeof(double));

  rinterleavef_nolim(stdin, &numsp, &nsite, name, seqc);
  letter(numsp, nsite, seqc);
  if (crit_id != 1) rmgap(numsp, &nsite, seqc);
  for(i = 0; i < nsite*numsp; i++)
    seq[i] = l2ip(seqc[i]);
  create_fmat(numsp,nsite,seq,fmat,fr);
  if (crit_id == 1) get_nsitev(numsp,nsite,seq,nsitev);

  if (crit_id == 5 || crit_id == 6) create_pfarray(numsp,nsite,seq,pfarray);

  for(nbin = nbinl; nbin <= nbinu; nbin++){
    crit_new = 1.0e+20; 
    if(binfile_in!=NULL){
      for(i = 0; i < 20; i++) fscanf(binfile_in, "%i", &bint[i]);
      crit_new = best_bin_chisq(numsp,nsitev,nbin,bint,fmat,fr,pfarray,crit_id);
      for(i = 0; i < NCHAR; i++) bin[i] = bint[i];
    }
    for(irand = 0; irand < nrand; irand++){
      binrandf(nbin,bint);
      crit = best_bin_chisq(numsp,nsitev,nbin,bint,fmat,fr,pfarray,crit_id);
      if (crit < crit_new){
	for(i = 0; i < NCHAR; i++) bin[i] = bint[i];
	crit_new = crit;
	if (crit_new <= 0.0) break;
      }
    }
    printf("%i %.5f \n", nbin, 1 - pchisq(crit_new,nbin-1));
    for(i = 0; i < NCHAR; i++) fprintf(binfile,"%i ", bin[i]);
    fprintf(binfile,"\n");
  }
  fclose(binfile);
  return(0);
}
